"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNearestProgram = getNearestProgram;
exports.buildCommandNotFoundHint = buildCommandNotFoundHint;
exports.getNearestScript = getNearestScript;
exports.getNearest = getNearest;
const didyoumean2_1 = __importStar(require("didyoumean2"));
const fs_1 = require("fs");
const path_1 = __importDefault(require("path"));
function getNearestProgram({ dir, modulesDir, programName, workspaceDir, }) {
    try {
        const binDir = path_1.default.join(dir, modulesDir, '.bin');
        const programList = readProgramsFromDir(binDir);
        if (workspaceDir && workspaceDir !== dir) {
            const workspaceBinDir = path_1.default.join(workspaceDir, modulesDir, '.bin');
            programList.push(...readProgramsFromDir(workspaceBinDir));
        }
        return getNearest(programName, programList);
    }
    catch {
        return null;
    }
}
function readProgramsFromDir(binDir) {
    const files = (0, fs_1.readdirSync)(binDir);
    if (process.platform !== 'win32')
        return files;
    const executableExtensions = ['.cmd', '.bat', '.ps1', '.exe', '.com'];
    return files.map((fullName) => {
        const { name, ext } = path_1.default.parse(fullName);
        return executableExtensions.includes(ext.toLowerCase()) ? name : fullName;
    });
}
function buildCommandNotFoundHint(scriptName, scripts) {
    let hint = `Command "${scriptName}" not found.`;
    const nearestCommand = getNearestScript(scriptName, scripts);
    if (nearestCommand) {
        hint += ` Did you mean "pnpm run ${nearestCommand}"?`;
    }
    return hint;
}
function getNearestScript(scriptName, scripts) {
    return getNearest(scriptName, Object.keys(scripts ?? []));
}
function getNearest(name, list) {
    if (list == null || list.length === 0)
        return null;
    return (0, didyoumean2_1.default)(name, list, {
        returnType: didyoumean2_1.ReturnTypeEnums.FIRST_CLOSEST_MATCH,
    });
}
//# sourceMappingURL=buildCommandNotFoundHint.js.map