import { type RecursiveSummary } from '@pnpm/cli-utils';
import { type Config } from '@pnpm/config';
import { type ProjectsGraph, type ProjectRootDir } from '@pnpm/types';
export declare const shorthands: Record<string, string | string[]>;
export declare const commandNames: string[];
export declare function rcOptionsTypes(): Record<string, unknown>;
export declare const cliOptionsTypes: () => Record<string, unknown>;
export declare function help(): string;
export declare function getResumedPackageChunks({ resumeFrom, chunks, selectedProjectsGraph, }: {
    resumeFrom: string;
    chunks: ProjectRootDir[][];
    selectedProjectsGraph: ProjectsGraph;
}): ProjectRootDir[][];
export declare function writeRecursiveSummary(opts: {
    dir: string;
    summary: RecursiveSummary;
}): Promise<void>;
export declare function createEmptyRecursiveSummary(chunks: string[][]): RecursiveSummary;
export declare function getExecutionDuration(start: [number, number]): number;
export type ExecOpts = Required<Pick<Config, 'selectedProjectsGraph'>> & {
    bail?: boolean;
    unsafePerm?: boolean;
    reverse?: boolean;
    sort?: boolean;
    workspaceConcurrency?: number;
    shellMode?: boolean;
    resumeFrom?: string;
    reportSummary?: boolean;
    implicitlyFellbackFromRun?: boolean;
} & Pick<Config, 'bin' | 'dir' | 'extraBinPaths' | 'extraEnv' | 'lockfileDir' | 'modulesDir' | 'nodeOptions' | 'pnpmHomeDir' | 'rawConfig' | 'recursive' | 'reporterHidePrefix' | 'userAgent' | 'workspaceDir'>;
export declare function handler(opts: ExecOpts, params: string[]): Promise<{
    exitCode: number;
}>;
