import { type CompletionFunc } from '@pnpm/command';
import { type Config } from '@pnpm/config';
import { type RunLifecycleHookOptions } from '@pnpm/lifecycle';
import { type ProjectManifest } from '@pnpm/types';
import { type RecursiveRunOpts } from './runRecursive';
export declare const IF_PRESENT_OPTION: Record<string, unknown>;
export interface DescriptionItem {
    shortAlias?: string;
    name: string;
    description?: string;
}
export declare const IF_PRESENT_OPTION_HELP: DescriptionItem;
export declare const PARALLEL_OPTION_HELP: DescriptionItem;
export declare const RESUME_FROM_OPTION_HELP: DescriptionItem;
export declare const SEQUENTIAL_OPTION_HELP: DescriptionItem;
export declare const REPORT_SUMMARY_OPTION_HELP: DescriptionItem;
export declare const REPORTER_HIDE_PREFIX_HELP: DescriptionItem;
export declare const shorthands: Record<string, string[]>;
export declare function rcOptionsTypes(): Record<string, unknown>;
export declare function cliOptionsTypes(): Record<string, unknown>;
export declare const completion: CompletionFunc;
export declare const commandNames: string[];
export declare function help(): string;
export type RunOpts = Omit<RecursiveRunOpts, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'> & {
    recursive?: boolean;
} & Pick<Config, 'bin' | 'dir' | 'enablePrePostScripts' | 'engineStrict' | 'extraBinPaths' | 'extraEnv' | 'nodeOptions' | 'pnpmHomeDir' | 'reporter' | 'scriptShell' | 'scriptsPrependNodePath' | 'shellEmulator' | 'userAgent'> & ({
    recursive?: false;
} & Partial<Pick<Config, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'>> | {
    recursive: true;
} & Required<Pick<Config, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'>>) & {
    argv?: {
        original: string[];
    };
    fallbackCommandUsed?: boolean;
};
export declare function handler(opts: RunOpts, params: string[]): Promise<string | {
    exitCode: number;
} | undefined>;
export interface RunScriptOptions {
    enablePrePostScripts: boolean;
}
export declare function runScript(opts: {
    manifest: ProjectManifest;
    lifecycleOpts: RunLifecycleHookOptions;
    runScriptOptions: RunScriptOptions;
    passedThruArgs: string[];
}, scriptName: string): Promise<void>;
